class PrequelError extends Error {
  name = "PrequelError";

  constructor(message: string) {
    super(`PrequelError: ${message}`);
  }
}

export class SchemaError extends PrequelError {
  constructor(message: string, table?: string, column?: string) {
    if (typeof table === "string" && typeof column === "string") {
      super(`SchemaError: ${message} ON ${table}.${column}`);
    } else if (typeof table === "string") {
      super(`SchemaError: ${message} ON ${table}`);
    } else {
      super(`SchemaError: ${message}`);
    }
  }
}

export class LookupFailure extends PrequelError {
  constructor(tableName: string, conditions: unknown) {
    super(
      `Conditions ${JSON.stringify(conditions)} returned no results from ${tableName}`,
    );
  }
}
